/****************************************************************************
 * $Id: serial_test3.c,v 1.6 1998/01/22 05:47:52 kevine Exp $
 * Copyright (C) 1997, 1998 Kevin Elphinstone, Univeristy of New South
 * Wales.
 *
 * This file is part of the L4/MIPS micro-kernel distribution.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 ****************************************************************************/
#include <libc.h>
#include <assert.h>
#include <l4/ipc.h>
#include <l4/syscalls.h>

static const l4_threadid_t SERIAL_TID = {0x60001};
static const l4_threadid_t SONIC_TID = {0x80001};

main()
{
  int r;
  l4_msgdope_t result;
  l4_ipc_reg_msg_t msg;
  char *c;
  l4_threadid_t tid;
  long count;
  count = 0;
  tid = l4_myself();

  c = (char *) &msg.reg[0];
  sprintf(c, "My thread id is 0x%x\r\n",tid);
  r = l4_mips_ipc_send(SERIAL_TID, L4_IPC_SHORT_MSG, &msg,
		       L4_IPC_NEVER, &result);
 



  while (1)
  {
    r = l4_ipc_sleep(L4_IPC_TIMEOUT(0,0,2,6,0,0),&result);

    r = l4_mips_ipc_call(SONIC_TID, L4_IPC_SHORT_MSG, &msg,
			 L4_IPC_SHORT_MSG,
			 &msg, L4_IPC_NEVER, &result);
    assert(r == 0);

    count++;
    sprintf(c,"count = %lld, time = %lu\r\n", count, msg.reg[0]);
    r = l4_mips_ipc_send(SERIAL_TID, L4_IPC_SHORT_MSG,  &msg,
		  L4_IPC_NEVER, &result);

    
    assert(r == 0);

  }
}

